/*******************************************************************************
  File: XdrStream.cpp
  Copyright (c) 1999 Bleading Edge Software Technologies, Inc.

  This Software is distributed under the open source, free software model.
  Permission to use, modify, and distribute this Software, including
  incorporating it into proprietary software, is granted without fee,
  provided this copyright notice appear in all copies of the code.
  You are under no obligation to distribute source code which is derived 
from
  or uses this Software. You may not do anything however, to prevent the
  continued distribution of this Software under an open source distribution
  model. This includes, but is not limited to, such things as copyrighting
  or claiming authorship of the Software.
  This Software is distributed in the hope that it will be useful, but it is
  provide "as is", WITHOUT ANY WARRANTY; without even the implied warranty
  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

//$-----------------------------------------------------------------------------
$Header:$
  Author: Jack W. Reeves

//!----------------------------------------------------------------------------|
Description:
  Implements the basic operations of XDR_Stream. See also 
XDRStream_reader.cpp
  for the implementation of iXDR_Stream, and XDRStream_writer.cpp for the
  implementation of oXDR_Stream and XDR_Stream.

//#----------------------------------------------------------------------------|
Notes:

//*****************************************************************************/

#include "XDRStream.h"

// Standard C++ headers
#include <algorithm>

namespace Util {

//
// XDR_Char
//
void
XDR_Char::swap_bytes()
{
	std::swap(data[0], data[3]);
	std::swap(data[1], data[2]);
}


void
XDR_Char::pad(int i)
{
	while (i > 0) {
		data[sizeof(data) - i] = '\0';
		--i;
	}
}

} //> namespace

//
// std::char_traits<XDR_Char>
//
std::char_traits<Util::XDR_Char>::char_type*
std::char_traits<Util::XDR_Char>::move(char_type* s1, const char_type* s2, 
size_t n);

std::char_traits<Util::XDR_Char>::char_type*
std::char_traits<Util::XDR_Char>::copy(char_type* s1, const char_type* s2, 
size_t n)
{
	for (int i = 0; size_t(i) < n; ++i)
		assign(s1[i], s2[i]);
	return s1;
}




