#ifndef cdc_bat_h_
#define cdc_bat_h_

#include "cdc_tbl.h"

typedef struct cdc_bat
{
  cdc_tbl_t     tbl;        /* basic table info       */
  unsigned long count;      /* # of valid BAT entries */
  unsigned long first_free; /* first free BAT entry   */
} cdc_bat_t;

int cdc_bat_init(cdc_t *cdc, unsigned long block);
int cdc_bat_cleanup(cdc_t *cdc);
int cdc_bat_hdr_write(cdc_t *cdc, char *ptr, size_t *sz);
int cdc_bat_hdr_read(cdc_t *cdc, const char *ptr, const char **eptr);
int cdc_bat_flush(
  cdc_t *cdc
  );
int cdc_bat_entry_get(
  cdc_t         *cdc, 
  unsigned long  entry, 
  unsigned long *value
  );
int cdc_bat_entry_set(
  cdc_t         *cdc,
  unsigned long  entry,
  unsigned long  value
  );
int cdc_bat_entry_alloc(
  cdc_t         *cdc,
  unsigned long *value
  );
int cdc_bat_entry_free(
  cdc_t         *cdc,
  unsigned long  value
  );
int cdc_bat_tbl_create(cdc_t *cdc);
int cdc_bat_counters_get(cdc_t *cdc, comprio_stat_t *buf);

#endif /* cdc_bat_h_ */

