#ifndef cdc_blk_h__
#define cdc_blk_h__

#include "comprio.h"

typedef struct cdc_blk
{
  unsigned long     blocks; /* # of blocks in file     */
  unsigned long     size;   /* bytes / block  */
  comprio_counter_t counter;
} cdc_blk_t;

int cdc_blk_counters_get(cdc_t *cdc, comprio_stat_t *buf);

int cdc_blk_read(
  cdc_t         *cdc, 
  unsigned long  block, 
  void          *buf,
  unsigned long  count,
  unsigned long *result
  );
int cdc_blk_write(
  cdc_t        *cdc,
  unsigned long block, 
  const void    *buf,
  unsigned long count
  );
int cdc_blk_init(cdc_t *cdc, unsigned long size);
int cdc_blk_cleanup(cdc_t *cdc);
int cdc_blk_hdr_write(cdc_t *cdc, char *ptr, size_t *sz);
int cdc_blk_hdr_read(cdc_t *cdc, const char *ptr, const char **eptr);

#endif /* cdc_blk_h__ */

