#ifndef cdc_data_h__
#define cdc_data_h__

typedef struct cdc_data
{
  unsigned long     blocks; /* blocks / cluster */
  unsigned long     size;   /* bytes / cluster  */
  comprio_counter_t counter;
  /*
   * one full data cluster
   */
  struct
  {
    int           dirty;   /* 0 = clean, 1 = must flush      */
    unsigned long cluster; /* cluster (entry into map table) */
    void         *buffer;  /* 1 cluster buffer               */
  } cluster;
  char          *zbuffer;  /* 1 cluster compress buffer      */
} cdc_data_t;

int cdc_data_init(cdc_t *cdc, unsigned long blocks);
int cdc_data_cleanup(cdc_t *cdc);
int cdc_data_hdr_write(cdc_t *cdc, char *ptr, size_t *sz);
int cdc_data_hdr_read(cdc_t *cdc,  const char *ptr, const char **eptr);

int cdc_data_read(cdc_t *cdc, unsigned long cluster);
int cdc_data_flush(cdc_t *cdc);
int cdc_data_counters_get(cdc_t *cdc, comprio_stat_t *buf);
#endif /* cdc_data_h__ */

