#ifndef cdc_env_h__
#define cdc_env_h__

#include <sys/stat.h>

struct cdc_env
{
  /*
   * create info
   */
  size_t   blk_size;
  size_t   blk_per_cluster;
  size_t   blk_per_map;
  size_t   blk_per_bat;
  /*
   * file i/o functions
   */
  int     (*open)(const char *, int, ...);
  int     (*close)(int);
  ssize_t (*read)(int, void *, size_t);
  ssize_t (*write)(int, const void *, size_t);
  off_t   (*seek)(int, off_t, int);
  int     (*sync)(int);
  int     (*stat)(int, struct stat *buf);
  /*
   * compression functions
   */
  struct
  {
    void     *arg;
    int     (*init)(void *arg);
    int     (*cleanup)(void *arg);
    int     (*fn)(
      void       *arg,
      void       *dst, 
      size_t     *dst_sz,
      const void *src, 
      size_t      src_sz
      );
  } deflate;
  struct
  {
    void     *arg;
    int     (*init)(void *arg);
    int     (*cleanup)(void *arg);
    int     (*fn)(
      void       *arg,
      void       *dst, 
      size_t     *dst_sz,
      const void *src, 
      size_t      src_sz 
      );
  } inflate;
};
  
extern comprio_env_t cdc_base_env;

#endif /* cdc_env_h__ */

